require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    eval 'sub _IMMINTRIN_H_INCLUDED () {1;}' unless defined(&_IMMINTRIN_H_INCLUDED);
    if(defined(&__MMX__)) {
	require 'mmintrin.ph';
    }
    if(defined(&__SSE__)) {
	require 'xmmintrin.ph';
    }
    if(defined(&__SSE2__)) {
	require 'emmintrin.ph';
    }
    if(defined(&__SSE3__)) {
	require 'pmmintrin.ph';
    }
    if(defined(&__SSSE3__)) {
	require 'tmmintrin.ph';
    }
    if(defined ( &__SSE4_2__) || defined ( &__SSE4_1__)) {
	require 'smmintrin.ph';
    }
    if(defined ( &__AES__) || defined ( &__PCLMUL__)) {
	require 'wmmintrin.ph';
    }
    if(defined(&__AVX__)) {
	require 'avxintrin.ph';
    }
    if(defined(&__RDRND__)) {
	eval 'sub __attribute__ {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand16_step (\'unsigned short\' * &__P) {  &__builtin_ia32_rdrand16_step ( &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand32_step (\'unsigned int\' * &__P) {  &__builtin_ia32_rdrand32_step ( &__P); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__x86_64__)) {
	if(defined(&__FSGSBASE__)) {
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readfsbase_u32 ( &void) {  &__builtin_ia32_rdfsbase32 (); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readfsbase_u64 ( &void) {  &__builtin_ia32_rdfsbase64 (); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readgsbase_u32 ( &void) {  &__builtin_ia32_rdgsbase32 (); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readgsbase_u64 ( &void) {  &__builtin_ia32_rdgsbase64 (); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writefsbase_u32  {  &__builtin_ia32_wrfsbase32 ( &__B); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writefsbase_u64  {  &__builtin_ia32_wrfsbase64 ( &__B); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writegsbase_u32  {  &__builtin_ia32_wrgsbase32 ( &__B); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writegsbase_u64  {  &__builtin_ia32_wrgsbase64 ( &__B); });
	    }' unless defined(&__attribute__);
	}
	if(defined(&__RDRND__)) {
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand64_step (my $long * &__P) {  &__builtin_ia32_rdrand64_step ( &__P); });
	    }' unless defined(&__attribute__);
	}
    }
    if(defined(&__F16C__)) {
	eval 'sub __attribute__ {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtsh_ss  {  &__v8hi  &__H = ( &__v8hi){  &__S, 0, 0, 0, 0, 0, 0, 0};  &__v4sf  &__A =  &__builtin_ia32_vcvtph2ps ( &__H);  &__builtin_ia32_vec_ext_v4sf ( &__A, 0); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtph_ps ( &__m128i  &__A) { ( &__m128)  &__builtin_ia32_vcvtph2ps (( &__v8hi)  &__A); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtph_ps ( &__m128i  &__A) { ( &__m256)  &__builtin_ia32_vcvtph2ps256 (( &__v8hi)  &__A); });
	}' unless defined(&__attribute__);
	if(defined(&__OPTIMIZE__)) {
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtss_sh (\'float\'  &__F,  &const \'int\'  &__I) {  &__v4sf  &__A = ( &__v4sf){  &__F, 0, 0, 0};  &__v8hi  &__H =  &__builtin_ia32_vcvtps2ph ( &__A,  &__I);   &__builtin_ia32_vec_ext_v8hi ( &__H, 0); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtps_ph ( &__m128  &__A,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_vcvtps2ph (( &__v4sf)  &__A,  &__I); });
	    }' unless defined(&__attribute__);
	    eval 'sub __attribute__ {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_ph ( &__m256  &__A,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_vcvtps2ph256 (( &__v8sf)  &__A,  &__I); });
	    }' unless defined(&__attribute__);
	} else {
	    eval 'sub _cvtss_sh {
	        my($__F, $__I) = @_;
    		eval q(( &__extension__ ({  &__v4sf  &__A =  &__extension__ ( &__v4sf){ $__F, 0, 0, 0};  &__v8hi  &__H =  &__builtin_ia32_vcvtps2ph ( &__A, $__I);   &__builtin_ia32_vec_ext_v8hi ( &__H, 0); })));
	    }' unless defined(&_cvtss_sh);
	    eval 'sub _mm_cvtps_ph {
	        my($A, $I) = @_;
    		eval q((( &__m128i)  &__builtin_ia32_vcvtps2ph (( &__v4sf)( &__m128) $A, ($I))));
	    }' unless defined(&_mm_cvtps_ph);
	    eval 'sub _mm256_cvtps_ph {
	        my($A, $I) = @_;
    		eval q((( &__m128i)  &__builtin_ia32_vcvtps2ph256 (( &__v8sf)( &__m256) $A, ($I))));
	    }' unless defined(&_mm256_cvtps_ph);
	}
    }
}
1;
