require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_PERCPU_RWSEM_H)) {
    eval 'sub _LINUX_PERCPU_RWSEM_H () {1;}' unless defined(&_LINUX_PERCPU_RWSEM_H);
    require 'linux/mutex.ph';
    require 'linux/percpu.ph';
    require 'linux/rcupdate.ph';
    require 'linux/delay.ph';
    require 'asm/local.ph';
    eval 'sub light_mb () {
        eval q( &smp_mb());
    }' unless defined(&light_mb);
    eval 'sub heavy_mb () {
        eval q( &smp_mb());
    }' unless defined(&heavy_mb);
    eval 'sub percpu_down_read {
        my($p) = @_;
	    eval q({  &rcu_read_lock();  &if ( &unlikely( ($p->{locked}))) {  &rcu_read_unlock();  &mutex_lock( ($p->{mtx}));  &preempt_disable();  &local_inc( &per_cpu_ptr( ($p->{counters}),  &smp_processor_id()));  &preempt_enable();  &mutex_unlock( ($p->{mtx})); ; }  &preempt_disable();  &local_inc( &per_cpu_ptr( ($p->{counters}),  &smp_processor_id()));  &preempt_enable();  &rcu_read_unlock();  &light_mb(); });
    }' unless defined(&percpu_down_read);
    eval 'sub percpu_up_read {
        my($p) = @_;
	    eval q({  &light_mb();  &preempt_disable();  &local_dec( &per_cpu_ptr( ($p->{counters}),  &smp_processor_id()));  &preempt_enable(); });
    }' unless defined(&percpu_up_read);
    eval 'sub __percpu_count {
        my($counters) = @_;
	    eval q({ my $total = 0; \'int\'  &cpu;  &for_each_possible_cpu( &cpu)  $total +=  &local_read( &per_cpu_ptr($counters,  &cpu));  $total; });
    }' unless defined(&__percpu_count);
    eval 'sub percpu_down_write {
        my($p) = @_;
	    eval q({  &mutex_lock( ($p->{mtx}));  ($p->{locked}) =  &true;  &synchronize_rcu();  &while ( &__percpu_count( ($p->{counters})))  &msleep(1);  &heavy_mb(); });
    }' unless defined(&percpu_down_write);
    eval 'sub percpu_up_write {
        my($p) = @_;
	    eval q({  &heavy_mb();  ($p->{locked}) =  &false;  &mutex_unlock( ($p->{mtx})); });
    }' unless defined(&percpu_up_write);
    eval 'sub percpu_init_rwsem {
        my($p) = @_;
	    eval q({ \'int\'  &cpu;  ($p->{counters}) =  &alloc_percpu( &local_t);  &if ( &unlikely(! ($p->{counters}))) - &ENOMEM;  &for_each_possible_cpu( &cpu)  &local_set( &per_cpu_ptr( ($p->{counters}),  &cpu), 0);  ($p->{locked}) =  &false;  &mutex_init( ($p->{mtx})); 0; });
    }' unless defined(&percpu_init_rwsem);
    eval 'sub percpu_free_rwsem {
        my($p) = @_;
	    eval q({  &free_percpu( ($p->{counters}));  ($p->{counters}) =  &NULL; });
    }' unless defined(&percpu_free_rwsem);
}
1;
